#ifndef _RSM_MAIN_WINDOW_H_
#define _RSM_MAIN_WINDOW_H_

#include "mnemosyne/definitions.h"

#include "WDL/wingui/wndsize.h"

class RSM_MainWnd
{
public:
  RSM_MainWnd();
  ~RSM_MainWnd();

  HWND Handle() { return m_hwnd; }

  static WDL_DLGRET MainWndProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam);
private:
  void OnInitDialog();
  void OnSysCommand();
  int OnClose();
  void OnSize();
  void OnMove();
  int OnDestroy();
  void OnCommand();
  void OnTimer();
  WDL_DLGRET MainWndLoop(UINT msg, WPARAM wparam, LPARAM lparam);

  HWND m_hwnd;
  UINT m_msg;
  WPARAM m_wparam;
  LPARAM m_lparam;
  int m_x, m_y, m_w, m_h;
  WDL_WndSizer m_resize;
  HMENU m_main_menu;
};

#endif // _RSM_MAIN_WINDOW_H_
